#include <stdio.h>
#include <iostream.h>
#include <ctype.h>
#include <string>
#include <stdlib.h>
#include <fstream>
#include <unistd.h>
#include <fcntl.h>
#include <sys/file.h>
#include "htnews.h"

extern string SENDER;

string getval(const string& buf, const string& param)
{
        string::size_type pos;
        string tmp(""), out("");
        int stop=0;
        int yes=1;
        int no=0;
        int len;
        pos = buf.find(param);
        if( pos != string::npos )
                tmp.assign(buf, pos + param.length());
        else
                return "";
        len = tmp.length();
        for(int i=0;i<len;i++)
        {
                if((tmp[i] != ' ') || (stop != no))
                {
                        stop = yes;
                        out += tmp[i];
                }
        }
	
	tmp = out; // reuse out!!!
	len = tmp.length();
	//cout << param << "(" << len << "): ";
	for(int i=len;i>=0;i--)
	{
		// remove trailing space(es)
		if((tmp[i] != ' ') && (tmp[i] != '\n') && (tmp[i] != '\t'))
		{
			out.assign(tmp, 0,i+1);
			//cout << out << "(" << i << ").\n";
			break;
		}
	}
        return out;
}

string replace(const string& line)
{
        int i, u;
        string temp("");
        i = line.length();
        for(u=0;u<i;u++)
        {
                if(line[u] == '"')
                        temp += "\\\"";
                else
                        temp += line[u];
        }
        return temp;
}


void error()
{
        cerr 	<< "usage:    htnews [-c | -C | -a | -A configfile]\n"
			 	<< "Options:  -c use specified configfile\n"
				<< "          -C use config in old format\n"
				<< "          -a run in cron mode\n"
				<< "          -A run in cron mode using old format.\n"
				<< "Please note, that the options -C and -A will not be available\n"
				<< "in the next version of htnews. These are provided to give you\n"
				<< "the chance to migrate to the new config format.\n";
		
        exit(1);
}

void err(string Tmp_File, string MSG, string Admin)
{
        ofstream Tmp("/tmp/htnews.err");
        Tmp << MSG;
        if(Tmp_File == "Standard")
        {
                Tmp << "This seems to be a configuration error.\n";
        }
        else if(Tmp_File == "refresh")
                Tmp << "\n";
		else if(Tmp_File == "refresh-error")
				Tmp << "\n";
        else
        {
                Tmp << "\n\n--- Original Message follows ---\n\n";
                Tmp.close();
                string CPY("cat ");
                CPY.append(Tmp_File);
                CPY.append(" >> ");
                CPY.append("/tmp/htnews.err");
                system(CPY.c_str());
        }
        Tmp.close();
        string CMD("");
        CMD.append("(echo \"From: ");
        CMD.append(SENDER);
        CMD.append("\"; echo \"To: ");
        CMD.append(Admin);
        CMD.append("\"; echo \"Subject: ");
        if(Tmp_File != "refresh")
                CMD.append("Error while trying to access htnews robot.\"; echo; echo \"");
        else
                CMD.append("Refresh done.\"; echo; echo \"");
        CMD.append("`cat /tmp/htnews.err`");
        CMD.append("\n");
		CMD.append("\nmessage created by htnews ");
		CMD.append(VERSION);
		CMD.append(".\n");
        CMD.append("\") | " + string(_SENDMAIL) + " -t");
        system(CMD.c_str());
        system("rm /tmp/htnews.*");
        exit(0);
}


int hex2int(const string& line)
{
        int value=0;
        char input[80]; // ok, because line is limited to 76 chars!
	strcpy(input, line.c_str());
        if(isxdigit(*input))
        {
                sscanf(input, "%02X", &value);
        }
	return value;
}

string quoted2html(const string& quoted)
{
	/*
	 * This function converts quoted-printable chars to html
	 *
	 * i.e.:
	 * in = "<body bgcolor=3D\"#ffffff\">\n<title>T=4Ften=3D=3F=\n</title>\n";
	 * would be:
	 * "<body bgcolor="#ffffff">\n<title>T&#79;ten=&#63;</title>"
	 * 
	 * everything after a "=" will be converted with the function hex2int to an 
	 * int, which will be passed into html-code like "&#int;" (where int is the number)
	 * If the "=" is the last char on a line (directly followed by '\n', then
	 * it is a "soft-linebreak" and will not be transtated to a linebreak.
	 * If a "=3D" occurs, which is int 61, then a "=" will be translated.
	 *
	 * If a "=20" occurs, a ' ' (blank) will be translated. If after the blank a
	 * newline follows, this newline will be removed, since the output is html this
	 * does not matter. And there will no breaked tags be anymore. Example:
	 * "<font size=3D2=20
	 * "face=3Darial>"
	 * will be:
	 * "<font size=2 face=arial>"
	 */
	string New(""), tocheck("");
	char buf[5];
	int i, len;
	len = quoted.length();
	for(i=0;i<len;i++)
	{
		if(quoted[i] == '=')
		{
			if(quoted[i+1] != '\n')
			{
				tocheck = "";
				tocheck += quoted[i+1];
				tocheck += quoted[i+2];
				if(hex2int(tocheck) == 61)
				{
					New += '=';
					i += 2;
				}
				else if(hex2int(tocheck) == 32)
				{
					New += ' ';
					if(quoted[i+3] == '\n')
						i += 3;
					else
						i += 2;	
				}
				else
				{
					sprintf(buf, "%d", hex2int(tocheck));
					New += "&#";
					New.append(buf);
					New += ";";
					i += 2;
				}
			}
			else
			{
				// remove the '\n'
				i++;
			}
		}
		else
			New += quoted[i];
	}
	return New;
}


string htmlize(const string& zeile)
{
	/* purpose:
	 * Replace \n with <br>
	 *         \t with 8 x &nbsp;
	 *         n' ' with n x &nbsp;
	 */
	
	string out("");
	int len, havespace=0;
	len = zeile.length();
	for(int i=0;i<len;i++)
	{
		if(havespace == 1)
		{
			if(zeile[i] == ' ')
				out += "&nbsp;";
			else
			{
				out += zeile[i];
				havespace = 0;
			}
		}
		else
		{
			if(zeile[i] == ' ')
			{
				havespace = 1;
				out += zeile[i];
			}
			else if(zeile[i] == '\t')
			{
				out += "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
			}
			else
				out += zeile[i];
		}
	}
	out += "<br>\n";
	return out;
}

int Exit()
{
	// last write-action to pidfile, so it stay opened during normal htnews operation.
	// close PID-file!
	// bad: if [ -e /tmp/htnews.pid ]; then rm /tmp/htnews.pid; fi
	system("if [ -e /var/run/htnews.pid ] ; then /bin/rm /var/run/htnews.pid; fi");
	exit(0);
}

struct flock* file_lock(short type, short whence)
{
        static struct flock ret;
        ret.l_type = type;
        ret.l_start = 0;
        ret.l_whence = whence;
        ret.l_len = 0;
        ret.l_pid = getpid();
        return &ret;
}

int lock(fstream file)
{
	//use fcntl to lock it
	fcntl(file.rdbuf()->fd(), F_SETLKW, file_lock(F_WRLCK, SEEK_SET));
}
